#pragma language glsl3
#extension GL_EXT_gpu_shader4 : enable
#extension GL_ARB_shader_bit_encoding : enable

uint baseHash(uvec2 p)
{
    p = 1103515245U*((p >> 1U)^(p.yx));
    uint h32 = 1103515245U*((p.x)^(p.y>>3U));
    return h32^(h32 >> 16);
}

vec4 hash42(vec2 x)
{
    uint n = baseHash(floatBitsToUint(x));
    uvec4 rz = uvec4(n, n*16807U, n*48271U, n*69621U);
    return vec4(rz & uvec4(0x7fffffffU))/float(0x7fffffff);
}

vec4 effect(vec4 col, Image tex, vec2 uv, vec2 fragCoord)
{	
    uv.x *= love_ScreenSize.x/love_ScreenSize.y;
    return vec4(hash42(uv).xyz, 1.0);
}